//+------------------------------------------------------------------+
//|                                                  swb grid 4 .mq4 |
//|                                                totom sukopratomo |
//|                                            forexengine@gmail.com |
//+------------------------------------------------------------------+

#property copyright "totom sukopratomo"
#property link      "forexengine@gmail.com"
#define buy -2
#define sell 2
//---- input parameters
extern bool      use_daily_target=false;
extern double    daily_target=100;
extern bool      trade_in_fri=true;
extern int       magic=1;
extern double    start_lot=0.1;
extern double    range=25;
extern int       level=10;
extern bool      lot_multiplier=true;
extern double    multiplier=2.0;
extern double    increament=0.1;
extern bool      use_sl_and_tp=false;
extern double    sl=100;
extern double    tp=800;
extern double    tp_in_money=5.0;
extern bool      stealth_mode=true;
extern bool      use_bb=true;
extern int       bb_period=20;
extern int       bb_deviation=2;
extern int       bb_shift=0;
extern bool      use_stoch=true;
extern int       k=5;
extern int       d=3;
extern int       slowing=3;
extern int       price_field=0;
extern int       stoch_shift=0;
extern int       lo_level=30;
extern int       up_level=70;
extern bool      use_rsi=true;
extern int       rsi_period=12;
extern int       rsi_shift=0;
extern int       lower=30;
extern int       upper=70;
double pt, dg;
double minlot;
double stoplevel;
int prec=0;
int ticket=0;
extern bool      TrailingProfitOnly=true;
extern double    TrailingStop=70;
extern double    TrailingStep=20;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   if(Digits==3 || Digits==5) pt=10*Point;
   else                          pt=Point;
   minlot   =   MarketInfo(Symbol(),MODE_MINLOT);
   stoplevel=MarketInfo(Symbol(),MODE_STOPLEVEL);
   dg=MarketInfo(OrderSymbol(),MODE_DIGITS);
   if(start_lot<minlot)      Print("lotsize is to small.");
   if(sl<stoplevel)   Print("stoploss is to tight.");
   if(tp<stoplevel) Print("takeprofit is to tight.");
   if(minlot==0.01) prec=2;
   if(minlot==0.1)  prec=1;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   if(use_daily_target && dailyprofit()>=daily_target)
   {
	 Comment("\ndaily target achieved.");
	 return(0);
   }
   if(!trade_in_fri && DayOfWeek()==5 && total()==0)
   {
	 Comment("\nstop trading in Friday.");
	 return(0);
   }
   if(total()==0)
   {
	 if(signal()==buy)
	 {
		if(stealth_mode)
		{
		  if(use_sl_and_tp) ticket=OrderSend(Symbol(),0,start_lot,Ask,3,Ask-sl*pt,Ask+tp*pt,"",magic,0,Blue);
		  else              ticket=OrderSend(Symbol(),0,start_lot,Ask,3,        0,        0,"",magic,0,Blue);
		}
		else
		{
		  if(use_sl_and_tp) 
		  {
			 if(OrderSend(Symbol(),0,start_lot,Ask,3,Ask-sl*pt,Ask+tp*pt,"",magic,0,Blue)>0)
			 {
				for(int i=1; i<level; i++)
				{
					if(lot_multiplier) ticket=OrderSend(Symbol(),2,NormalizeDouble(start_lot*MathPow(multiplier,i),prec),Ask-(range*i)*pt,3,(Ask-(range*i)*pt)-sl*pt,(Ask-(range*i)*pt)+tp*pt,"",magic,0,Blue);
					else               ticket=OrderSend(Symbol(),2,NormalizeDouble(start_lot+increament*i,prec)         ,Ask-(range*i)*pt,3,(Ask-(range*i)*pt)-sl*pt,(Ask-(range*i)*pt)+tp*pt,"",magic,0,Blue);
				}
			 }
		  }
		  else
		  {
			 if(OrderSend(Symbol(),0,start_lot,Ask,3,0,0,"",magic,0,Blue)>0)
			 {
				for(i=1; i<level; i++)
				{
					if(lot_multiplier) ticket=OrderSend(Symbol(),2,NormalizeDouble(start_lot*MathPow(multiplier,i),prec),Ask-(range*i)*pt,3,0,0,"",magic,0,Blue);
					else               ticket=OrderSend(Symbol(),2,NormalizeDouble(start_lot+increament*i,prec)         ,Ask-(range*i)*pt,3,0,0,"",magic,0,Blue);
				}
			 }
		  }
		}
	 }
	 if(signal()==sell)
	 {
		if(stealth_mode)
		{
		  if(use_sl_and_tp) ticket=OrderSend(Symbol(),1,start_lot,Bid,3,Bid+sl*pt,Bid-tp*pt,"",magic,0,Red);
		  else              ticket=OrderSend(Symbol(),1,start_lot,Bid,3,        0,        0,"",magic,0,Red);
		}
		else
		{
		  if(use_sl_and_tp) 
		  {
			 if(OrderSend(Symbol(),1,start_lot,Bid,3,Bid+sl*pt,Bid-tp*pt,"",magic,0,Red)>0)
			 {
				for(i=1; i<level; i++)
				{
					if(lot_multiplier) ticket=OrderSend(Symbol(),3,NormalizeDouble(start_lot*MathPow(multiplier,i),prec),Bid+(range*i)*pt,3,(Bid+(range*i)*pt)+sl*pt,(Bid+(range*i)*pt)-tp*pt,"",magic,0,Red);
					else               ticket=OrderSend(Symbol(),3,NormalizeDouble(start_lot+increament*i,prec)         ,Bid+(range*i)*pt,3,(Bid+(range*i)*pt)+sl*pt,(Bid+(range*i)*pt)-tp*pt,"",magic,0,Red);
				}
			 }
		  }
		  else
		  {
			 if(OrderSend(Symbol(),1,start_lot,Bid,3,0,0,"",magic,0,Red)>0)
			 {
				for(i=1; i<level; i++)
				{
					if(lot_multiplier) ticket=OrderSend(Symbol(),3,NormalizeDouble(start_lot*MathPow(multiplier,i),prec),Bid+(range*i)*pt,3,0,0,"",magic,0,Red);
					else               ticket=OrderSend(Symbol(),3,NormalizeDouble(start_lot+increament*i,prec)         ,Bid+(range*i)*pt,3,0,0,"",magic,0,Red);
				}
			 }
		  }
		}
	 } 
   }
   if(stealth_mode && total()>0 && total()<level)
   {
	 int type; double op, lastlot; 
	 for(i=0; i<OrdersTotal(); i++)
	 {
		 OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
		 if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic) continue;
		 type=OrderType();
		 op=OrderOpenPrice();
		 lastlot=OrderLots();
	 }
	 if(type==0 && Ask<=op-range*pt) 
	 {
		if(use_sl_and_tp)
		{
		   if(lot_multiplier) ticket=OrderSend(Symbol(),0,NormalizeDouble(lastlot*multiplier,prec),Ask,3,Ask-sl*pt,Ask+tp*pt,"",magic,0,Blue);
		   else               ticket=OrderSend(Symbol(),0,NormalizeDouble(lastlot+increament,prec),Ask,3,Ask-sl*pt,Ask+tp*pt,"",magic,0,Blue);
		}
		else
		{
		   if(lot_multiplier) ticket=OrderSend(Symbol(),0,NormalizeDouble(lastlot*multiplier,prec),Ask,3,0,0,"",magic,0,Blue);
		   else               ticket=OrderSend(Symbol(),0,NormalizeDouble(lastlot+increament,prec),Ask,3,0,0,"",magic,0,Blue);
		}
	 }
	 if(type==1 && Bid>=op+range*pt) 
	 {
		if(use_sl_and_tp)
		{
		   if(lot_multiplier) ticket=OrderSend(Symbol(),1,NormalizeDouble(lastlot*multiplier,prec),Bid,3,Bid+sl*pt,Bid-tp*pt,"",magic,0,Red);
		   else               ticket=OrderSend(Symbol(),1,NormalizeDouble(lastlot+increament,prec),Bid,3,Bid+sl*pt,Bid-tp*pt,"",magic,0,Red);
		}
		else
		{
		   if(lot_multiplier) ticket=OrderSend(Symbol(),1,NormalizeDouble(lastlot*multiplier,prec),Bid,3,0,0,"",magic,0,Red);
		   else               ticket=OrderSend(Symbol(),1,NormalizeDouble(lastlot+increament,prec),Bid,3,0,0,"",magic,0,Red);
		}
	 }
   }
   if(use_sl_and_tp && total()>1)
   {
	 double s_l, t_p;
	 for(i=0; i<OrdersTotal(); i++)
	 {
		 OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
		 if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic || OrderType()>1) continue;
		 type=OrderType();
		 s_l=OrderStopLoss();
		 t_p=OrderTakeProfit();
	 }
	 for(i=OrdersTotal()-1; i>=0; i--)
	 {
	   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
	   if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic || OrderType()>1) continue;
	   if(OrderType()==type)
	   {
		  if(OrderStopLoss()!=s_l || OrderTakeProfit()!=t_p)
		  {
			 OrderModify(OrderTicket(),OrderOpenPrice(),s_l,t_p,0,CLR_NONE);
		  }
	   }
	 }
   }
   double profit=0;
//+------------------------------------------------------------------+
   if(TrailingStop>0.0 && OrdersTotal()>0)
      TrailingPositions();
//+------------------------------------------------------------------+
   for(i=0; i<OrdersTotal(); i++)
   {
	  OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
	  if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic || OrderType()>1) continue;
	  profit+=OrderProfit();
   }
   return(0);
  }
//+------------------------------------------------------------------+
double dailyprofit()
{
  int day=Day(); double res=0;
  for(int i=0; i<OrdersHistoryTotal(); i++)
  {
	  OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
	  if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic) continue;
	  if(TimeDay(OrderOpenTime())==day) res+=OrderProfit();
  }
  return(res);
}
//+------------------------------------------------------------------+
int total()
{
  int total=0;
  for(int i=0; i<OrdersTotal(); i++)
  {
	  OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
	  if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic) continue;
	  total++;
  }
  return(total);
}
//+------------------------------------------------------------------+
int signal()
{
  double upBB=iBands(Symbol(),0,bb_period,bb_deviation,0,PRICE_CLOSE,MODE_UPPER,bb_shift);
  double loBB=iBands(Symbol(),0,bb_period,bb_deviation,0,PRICE_CLOSE,MODE_LOWER,bb_shift);
  double stoch=iStochastic(Symbol(),0,k,d,slowing,MODE_SMA,price_field,MODE_SIGNAL,stoch_shift);
  double rsi=iRSI(Symbol(),0,rsi_period,PRICE_CLOSE,rsi_shift);
  if(use_bb && use_stoch && use_rsi)
  {
	 if(High[bb_shift]>upBB && stoch>up_level && rsi>upper) return(sell);
	 if(Low[bb_shift]<loBB && stoch<lo_level && rsi<lower)   return(buy);
  }
  if(use_bb && use_stoch && !use_rsi)
  {
	 if(High[bb_shift]>upBB && stoch>up_level) return(sell);
	 if(Low[bb_shift]<loBB && stoch<lo_level)   return(buy);
  }
  if(use_bb && !use_stoch && !use_rsi)
  {
	 if(High[bb_shift]>upBB) return(sell);
	 if(Low[bb_shift]<loBB)   return(buy);
  }
  if(!use_bb && use_stoch && use_rsi)
  {
	 if(stoch>up_level && rsi>upper) return(sell);
	 if(stoch<lo_level && rsi<lower)   return(buy);
  }
  if(!use_bb && use_stoch && !use_rsi)
  {
	 if(stoch>up_level) return(sell);
	 if(stoch<lo_level)  return(buy);
  }
  if(use_bb && !use_stoch && use_rsi)
  {
	 if(High[bb_shift]>upBB && rsi>upper) return(sell);
	 if(Low[bb_shift]<loBB && rsi<lower)   return(buy);
  }
  if(!use_bb && !use_stoch && use_rsi)
  {
	 if(rsi>upper) return(sell);
	 if(rsi<lower)  return(buy);
  }
  
  
  return(0);
}
//+------------------------------------------------------------------+

void TrailingPositions(string sy="", double op=-1,double mn=-1)
{
  int dg, i, TrailForBuy=100, TrailForSell=100, CurPo;
  double CurBid, CurAsk;
 
  if (sy=="0") sy=Symbol();
  for(i=OrdersTotal()-1;i>=0;i--)
   { if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
	  { if( (OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op) && (mn<0 || OrderMagicNumber()==mn) )
		{ CurPo=MarketInfo(OrderSymbol(),MODE_POINT);
		   { if(OrderType()==OP_BUY)
			 { CurBid=MarketInfo(OrderSymbol(),MODE_BID);
			   TrailingStop=NormalizeDouble(TrailForBuy,dg);
				{ if(CurBid-OrderOpenPrice()>TrailingStop*CurPo)
				   {
				     if (OrderStopLoss()<CurBid-TrailingStop*CurPo)
				      {
				        ModifyOrder(-1, CurBid-TrailingStop*CurPo, -1);
				      }
				   }

				}  
			 } 
		   }

		   { if(OrderType()==OP_SELL)
			 { CurAsk=MarketInfo(OrderSymbol(),MODE_ASK);
			    TrailingStop=NormalizeDouble(TrailForSell,dg);
				{ if(OrderOpenPrice()-CurAsk>TrailingStop*CurPo)
				   { if(OrderStopLoss()<CurAsk+TrailingStop*CurPo)
                 
					   {
					     ModifyOrder(-1, CurAsk+TrailingStop*CurPo, -1);
					   }
				   } 
				}
			 }
		   }
		}
	  }
   }
}
//+-----------------------------------------------------------------+

void ModifyOrder(double pr=-1, double sl=0, double tp=0, color cl=CLR_NONE) {
  bool   SendMod, UseSound;
  double op, pa, pb, os, ot;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it, NumberOfTry=10;
 
  if (pr<=0) pr=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pr=NormalizeDouble(pr, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);
 
  if (pr!=op || sl!=os || tp!=ot) {
	for (it=1; it<=NumberOfTry; it++) {
	  if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
	  while (!IsTradeAllowed()) Sleep(5000);
	  RefreshRates();
	  SendMod=OrderModify(OrderTicket(), pr, sl, tp, 0, cl);
	  if (SendMod)
      {
        if (UseSound) PlaySound("expert.wav"); break;
      }
	   else {
		er=GetLastError();
		pa=MarketInfo(OrderSymbol(), MODE_ASK);
		pb=MarketInfo(OrderSymbol(), MODE_BID);
//		Print("Error(",er,") modifying order: ",ErrorDescription~(er),", try ",it);
//		Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
//			  "  op="+GetNameOP(OrderType()),"  pp=",pr,"  sl=",sl,"  tp=",tp);
		Sleep(1000*10);
	  }
	}
  }
}

